﻿* Encoding: UTF-8.
***************************************************************************
*   S O L O M O N  
*                                                                          
* AUTHOR:   URBANO LORENZO-SEVA
* URV, TARRAGONA (SPAIN)
* DATE: 17/JUNE/2021
*
***************************************************************************
*
* ENTER HERE THE PATH TO THE FOLDER WHERE YOU WANT TO SAVE YOUR FILES.
* USUALLY NO PATH IS NEEDED. HOWEVER, SOME OPERATIVE SYSTEMS ASK                           
* THE USER FOR A SPECIFIC PATH. AS A DEFAULT, NO PATH IS SPECIFIED.
*
*     HERE YOU HAVE TWO EXAMPLES.
*
*     EXAMPLE 1. NO PATH IS SPECIFIED:
*     define !Path ()"" !enddefine.
*
*     EXAMPLE 2. THE PATH C:\Dades\Users\uls\Desktop\solomon\ IS SPECIFIED:
*     define !Path ()"C:\Dades\Users\uls\Desktop\solomon\" !enddefine.

DEFINE !Path ()"" !enddefine.

***************************************************************************.
SET MXLOOP=10000.
matrix.
get rawdata /var=all /names=vnames/missing = omit.
compute x=rawdata.
compute n=nrow(x).
compute m=ncol(x).
compute ld=trunc((2*m + 1 - sqrt(8*m + 1))/2).
compute ones=make(n,1,1).
compute mx=csum(x)/n.
compute variance=(csum( (x-ones*mx) &* (x-ones*mx ) )/(n-1)).
compute sx=sqrt(variance).
compute Z=(x-ones*mx)&/(ones*sx).
compute ddata=x-ones*mx.
compute dSx=make(m,m,0).
call setdiag(dSx,sx).
compute R = inv(dSx)*(t(ddata)*ddata/(n))*inv(dSx)/(n).
call svd(R,U,S,V).
compute ld = 1.
loop #ii= 1 to m.
      do if S(#ii,#ii)*n GE 1.
           compute ld = ld+1.
      end if.
end loop.
compute Kq = U(1:m,1:ld).
compute Dq = S(1:ld,1:ld).
compute B = Kq * inv(sqrt(Dq*n)).
compute A = T(inv(T(B)*R*B) * T(B) * R).
compute sign=make(1,ld,1).
compute sA = csum(A).
loop #ii=1 to ld.
    do if sA(1,#ii) LT 0.
         compute sign(1,#ii)=-1.
end if.
end loop.
compute A = A &* (make(m,1,1)*sign).
compute pc_ld =Z*A. 
compute w = diag(S*n) / m.
compute w_ld = w(1:ld).
compute s = pc_ld*w_ld.
compute idx = grade(s(:,1)).
compute sss = make(n,1,1).
compute indi =make(n,1,0).
loop #ii= 1 to n.
     do if trunc(#ii/2) EQ #ii/2.
        compute sss(#ii,1)=2.
     end if.
    compute indi(#ii)=#ii.
end loop.
compute indi(idx)=indi.
compute sss(indi)=sss(:,1).
compute keep = make(n,m+1,0).
compute keep(:,1)   = sss(:,1).
compute tmpnames=make(1,21,0).
compute tmpnames(1,1)={'SOL'}.
loop #i=1 to m.
   compute tmpnames(1,(#i+1))={vnames(#i)}.
end loop.
compute keep(1:n,2:(m+1)) = x(1:n,1:m).
save keep /outfile=!Path +'tmp.sav' /names=tmpnames.
print / space = 2.
print /title="***************************************************************************".
print / space = 1.
print /title="                    S O L O M O N     S P S S   C O D E                    ".
print / space = 2.
print /title="                        Author: Urbano Lorenzo-Seva                        ".
print / space = 2.
print /title="               Universitat Rovira i Virgili, Tarragona, Spain              ".
print / space = 1.
print /title="                         Version: 1.03, June 2021                          ".
print / space = 3.
print /title="    SUBSAMPLES ARE IDENTIFIED BY VARIABLE:  SOLOMON                        ".
print / space = 1.
print /title="        Value 1:   First Solomon subsample                                 ".
print / space = 1.
print /title="        Value 2:   Second Solomon subsample                                ".
print / space = 1.
print /title="***************************************************************************".
print / space = 2.
end matrix.
get file !Path +'tmp.sav'.
VARIABLE LABELS SOL 'Somolon samples'.
VALUE LABELS SOL 1 'First Solomon subsample' 2 'Second Solomon subsample'.
FORMATS SOL (f1.0).
EXECUTE.
DATASET NAME SOLOMON.

*FACTOR ANALYSIS OF THE FIRST SOLOMON SAMPLE.
FACTOR
  /VARIABLES i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15 i16 i17 i18 i19 i20
  /MISSING LISTWISE 
  /ANALYSIS i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15 i16 i17 i18 i19 i20
  /SELECT=SOL(1)
  /PRINT INITIAL KMO EXTRACTION
  /CRITERIA FACTORS(1) ITERATE(100)
  /EXTRACTION ULS
  /ROTATION NOROTATE.

*FACTOR ANALYSIS OF THE SECOND SOLOMON SAMPLE.
FACTOR
  /VARIABLES i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15 i16 i17 i18 i19 i20
  /MISSING LISTWISE 
  /ANALYSIS i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15 i16 i17 i18 i19 i20
  /SELECT=SOL(2)
  /PRINT INITIAL KMO EXTRACTION
  /CRITERIA FACTORS(1) ITERATE(100)
  /EXTRACTION ULS
  /ROTATION NOROTATE.
